; 
    include \masm32\include\masm32rt.inc
; 
    .data
        hInst     dd          0
        hWnd      dd          0
        _x        dd          0
        _y        dd          0

        ; Tested pads from 1 to 15 bytes.

        db 1 dup(0)

        point1    POINT       <>
        point2    POINT       <>
        point3    POINT       <>
        point4    POINT       <>
        point5    POINT       <>
        point6    POINT       <>
        point7    POINT       <>
        point8    POINT       <>

        wcx       WNDCLASSEX  <>
        msg       MSG         <>
        className db          "test_class",0
    .code
; 
start:
; 
    mov hInst, rv(GetModuleHandle, NULL)
    mov wcx.cbSize,        sizeof WNDCLASSEX
    mov wcx.style,         CS_BYTEALIGNWINDOW
    mov wcx.lpfnWndProc,   OFFSET WndProc
    mov wcx.cbClsExtra,    NULL
    mov wcx.cbWndExtra,    NULL
    m2m wcx.hInstance,     hInst
    mov wcx.hbrBackground, rv(GetStockObject, BLACK_BRUSH)
    mov wcx.lpszMenuName,  NULL
    mov wcx.lpszClassName, OFFSET className
    mov wcx.hIcon,         rv(LoadIcon, NULL, IDI_APPLICATION)
    mov wcx.hCursor,       rv(LoadCursor, NULL, IDC_ARROW)
    mov wcx.hIconSm,       0
    invoke RegisterClassEx, ADDR wcx

    W = 600
    H = 450
    invoke GetSystemMetrics, SM_CXSCREEN
    shr eax, 1
    sub eax, W / 2
    mov _x, eax
    invoke GetSystemMetrics, SM_CYSCREEN
    shr eax, 1
    sub eax, H / 2
    mov _y, eax

    invoke CreateWindowEx,  WS_EX_OVERLAPPEDWINDOW,
                            ADDR className,
                            chr$("Test"),
                            WS_OVERLAPPED or WS_SYSMENU,
                            _x, _y, W, H,
                            NULL, NULL,
                            hInst, NULL
    mov hWnd, eax
    invoke ShowWindow, hWnd, SW_SHOWNORMAL
    invoke UpdateWindow, hWnd

  msgLoop:

    invoke PeekMessage, ADDR msg, NULL, 0, 0, PM_REMOVE
    .IF eax != 0
      .IF msg.message == WM_QUIT
        exit msg.wParam
      .ENDIF
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage, ADDR msg
      jmp   msgLoop
    .ELSE
      invoke InvalidateRgn, hWnd, NULL, 0
      jmp   msgLoop  
    .ENDIF

    exit msg.wParam
; 
WndProc proc hwnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    LOCAL nCount:DWORD
    LOCAL ps:PAINTSTRUCT
    LOCAL rc:RECT
    
    Switch uMsg

      Case WM_PAINT

        invoke BeginPaint, hwnd, ADDR ps

        invoke GetClientRect, hwnd, ADDR rc

        invoke nrandom, 0ffffffh
        invoke CreateSolidBrush, eax
        push eax

        invoke SelectObject, ps.hdc, eax
        push eax

        invoke nrandom, 7
        add eax, 2
        mov nCount, eax

        invoke nrandom, rc.right
        mov point1.x, eax
        invoke nrandom, rc.bottom
        mov point1.y, eax
        invoke nrandom, rc.right
        mov point2.x, eax
        invoke nrandom, rc.bottom
        mov point2.y, eax

        cmp nCount, 3
        jb  @F
        invoke nrandom, rc.right
        mov point3.x, eax
        invoke nrandom, rc.bottom
        mov point3.y, eax

        cmp nCount, 4
        jb  @F
        invoke nrandom, rc.right
        mov point4.x, eax
        invoke nrandom, rc.bottom
        mov point4.y, eax

        cmp nCount, 5
        jb  @F
        invoke nrandom, rc.right
        mov point5.x, eax
        invoke nrandom, rc.bottom
        mov point5.y, eax

        cmp nCount, 6
        jb  @F
        invoke nrandom, rc.right
        mov point6.x, eax
        invoke nrandom, rc.bottom
        mov point6.y, eax

        cmp nCount, 7
        jb  @F
        invoke nrandom, rc.right
        mov point7.x, eax
        invoke nrandom, rc.bottom
        mov point7.y, eax

        cmp nCount, 8
        jb  @F
        invoke nrandom, rc.right
        mov point8.x, eax
        invoke nrandom, rc.bottom
        mov point8.y, eax

      @@:

        invoke Polygon, ps.hdc, ADDR point1, nCount

        pop eax
        invoke SelectObject, ps.hdc, eax

        pop eax
        invoke DeleteObject, eax

        invoke EndPaint,hwnd,ADDR ps

      Case WM_CLOSE

        invoke DestroyWindow, hwnd

      Case WM_DESTROY

        invoke PostQuitMessage, NULL

      Default

        invoke DefWindowProc, hwnd, uMsg, wParam, lParam
        ret

    EndSw

    return 0
WndProc endp
; 
end start
